function loadops_v01()
	local file = openfile("wmBot/ops.cfg", "r")
	if file then
		local line = read(file)
		local s, e, name, levelstr, level
		while line do
			s, e, name = strfind(line, "(%S+) %d+")
			s, e, levelstr = strfind(line, "%S+ (%d+)")
			level = tonumber(levelstr)
			if name and level and (level >= 1) and (level <= 4) then
				local item = {
					name = name,
					level = 1,
					rights = { }
				}
				tinsert(ops.items, item)
				if level == 4 then
					owner = getn(ops.items)
					ops.items[owner].rights = {
						hubadmin = 1,
						opadmin = 1
					}
					ops.items[owner].level = ownerlevel
				end
			end
			line = read(file)
		end
		closefile(file)
	end
end

function loadops()
	ops.items = { }
	local file = openfile("wmBot/ops.dat", "r")
	if file then
		local line = read(file)
		while line do
			local s, e, name = strfind(line, "(%S+)%|%d+%|.*")
			local s, e, levelstr = strfind(line, "%S+%|(%d+)%|.*")
			local s, e, rightstr = strfind(line, "%S+%|%d+%|(.*)")
			if name and levelstr and rightstr then
				local level = tonumber(levelstr)
				if level < 1 then
					level = 1
				end
				if owner and (level >= ownerlevel) then
					level = ownerlevel - 1
				elseif level > ownerlevel then
					level = ownerlevel
				end
				local rights = parserights(rightstr)
				for right, value in rights do
					if not possrights[right] then
						rights[right] = nil
					end
				end
				local item = {
					name = name,
					level = level,
					rights = rights
				}
				tinsert(ops.items, item)
				if level == ownerlevel then
					owner = getn(ops.items)
				end
			end
			line = read(file)
		end
		closefile(file)
	else
		loadops_v01()
		saveops()
	end
end

function saveops()
	local file = openfile("wmBot/ops.dat", "w")
	for i = 1, getn(ops.items) do
		write(file, ops.items[i].name.."|"..ops.items[i].level.."|"..makerights(ops.items[i].rights).."\n")
	end
	closefile(file)
end

function loadphrases()
	phrases = { }
	local file = openfile("wmBot/phrases.dat", "r")
	if file then
		local line = read(file)
		while line do
			local s, e, key = strfind(line, "(.+)%|.+")
			local s, e, reply = strfind(line, ".+%|(.+)")
			if key and reply then
				phrases[key] = reply
			end
			line = read(file)
		end
		closefile(file)
	end
end

function savephrases()
	local file = openfile("wmBot/phrases.dat", "w")
	for key, reply in phrases do
		write(file, key.."|"..reply.."\n")
	end
	closefile(file)
end