--dofile("wmBot/log.lua")
dofile("wmBot/const.lua")
dofile("wmBot/helpers.lua")
dofile("wmBot/files.lua")
dofile("wmBot/commands.lua")

function welcome(user)
	local file = openfile("wmBot/welcome.txt", "r")			
	if file then
		local line = read(file)
		local text = ""
		local vars = {
			uzivatel = user.sName,
			jmenohubu = frmHub:GetHubName(),
			wmbot = aboutinfo,
			botname = botname,
			pocetuzivatelu = frmHub:GetUsersCount(),
			maxuzivatelu = frmHub:GetMaxUsers()
		}
		while line do
			line = replacevars(line, vars)
			text = text.."\013\010"..line
			line = read(file)
		end
		closefile(file)
		return text
	end
end

function install(owner)
	local item = {
		name = owner.sName,
		level = ownerlevel,
		rights = {
			hubadmin = 1, 
			opadmin = 1
		}
	}
	tinsert(ops.items, item)
	saveops()
	pm(owner, "Byl jste nastaven jako majitel hubu, skript je nyni pripraven prijmat prikazy.")
	installed = 1
end

function handlebotcmd(user, cmd)
	local name, f
	for name, f in commands do
		if strlower(strsub(cmd, 1, strlen(name))) == name and (strlen(cmd) == strlen(name) or strsub(cmd, strlen(name) + 1, strlen(name) + 1) == " ") then
			arg = strsub(cmd, strlen(name) + 2)
			-- odebrat mezery z konce a zacatku parametru
			while strsub(arg, 1, 1) == " " do
				arg = strsub(arg, 2)
			end
			while strsub(arg, strlen(arg)) == " " do
				arg = strsub(arg, 1, strlen(arg) - 1)
			end
			return f(user, arg)
		end			
	end
end

function recievedpm(user, text)
	if installed == 1 then
		if strsub(text, 1, 1) == "." then
			local cmd = strsub(text, 2)
			return handlebotcmd(user, cmd)
		else
			return handlebotcmd(user, text)
		end
	else
		if user.bOperator and text == config.installpw then
			install(user)
		end
	end
end

function recievedchat(user, text)
	if installed == 1 then
		if strsub(text, 1, 1) == "." then
			local cmd = strsub(text, 2)
			return handlebotcmd(user, cmd)
		else
			local longestkey = ""
			for key, reply in phrases do				
				if strfind(text, key) then
					if strlen(key) > strlen(longestkey) then
						longestkey = key
					end
				end
			end
			if longestkey ~= "" then
				local reply = phrases[longestkey]
				local vars = {
					uzivatel = user.sName
				}
				reply = replacevars(reply, vars)
				chat(reply)
			end
		end
	end
end

function Main()
--	resetlog()
	frmHub:RegBot(botname)
	chat("Spousti se "..aboutinfo.."...");
	loadops()
	if getn(ops.items) == 0 then
		installed = 0
	else
		installed = 1
	end
	if installed == 1 then
		if getn(modules) >= 1 then
			modulehelp = ""
			for index, value in modules do
				dofile("wmBot/modules/"..value.."/module.lua")
			end
		end
		loadphrases()
	end
	chat("Hotovo.");
	if installed == 0 then
		chat("Cekam na instalaci majitelem hubu.")
	end
end

function DataArrival(user, data)
	if strsub(data, 1, 1) == "<" then
		local s, e, text = strfind(data, "%<%S+%> (.*)|.*")
		local result = recievedchat(user, text)
		if result then
			chatfor(user, result)
		end
		if config.floodprotect == 1 then
			
		end
	elseif strsub(data, 1, 5) == "$To: " then
		local s, e, recipient = strfind(data, "%$To:%s*(%S+)%s*From:")
		if strlower(recipient) == strlower(botname) then
			local s, e, msg = strfind(data, "%$To:%s*%S+%s*From:%s*%S+%s*%$%<%S+%> (.*)|.*")
			if msg then
				local result = recievedpm(user, msg)
				if result then
					pm(user, result)
				end
			end
		end
	end
end

function NewUserConnected(user)
	if installed == 1 then
		if config.welcome == 1 then
			chatfor(user, welcome(user))
		elseif config.welcome == 2 then
			pm(user, welcome(user))
		end
	end
end

function OpConnected(user)
	if installed == 1 then
		if config.welcome == 1 then
			chatfor(user, welcome(user))
		elseif config.welcome == 2 then
			pm(user, welcome(user))
		end
	else
		pm(user, "Detekoval jsem prvni spusteni, pokud jste majitel hubu, poslete mi odblokovaci heslo na PM.")
	end
end